Index: uspace/lib/c/Makefile
===================================================================
--- uspace/lib/c/Makefile	(revision 6e569bf0a1ed0572a905d116f5a08b3ebd525710)
+++ uspace/lib/c/Makefile	(revision db9c88924815f5224f632a9114b5427633cf77dc)
@@ -112,4 +112,5 @@
 	generic/io/log.c \
 	generic/io/logctl.c \
+	generic/io/label.c \
 	generic/io/kio.c \
 	generic/io/klog.c \
Index: uspace/lib/c/generic/io/label.c
===================================================================
--- uspace/lib/c/generic/io/label.c	(revision db9c88924815f5224f632a9114b5427633cf77dc)
+++ uspace/lib/c/generic/io/label.c	(revision db9c88924815f5224f632a9114b5427633cf77dc)
@@ -0,0 +1,105 @@
+/*
+ * Copyright (c) 2015 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file Volume service API
+ */
+
+#include <errno.h>
+#include <io/label.h>
+#include <stdlib.h>
+#include <str.h>
+
+/** Format label type as string.
+ *
+ * @param ltype Label type
+ * @param rstr Place to return pointer to newly allocated string
+ * @return EOK on success, ENOMEM if out of memory
+ */
+int label_type_format(label_type_t ltype, char **rstr)
+{
+	const char *sltype;
+	char *s;
+
+	sltype = NULL;
+	switch (ltype) {
+	case lt_none:
+		sltype = "None";
+		break;
+	case lt_mbr:
+		sltype = "MBR";
+		break;
+	case lt_gpt:
+		sltype = "GPT";
+		break;
+	}
+
+	s = str_dup(sltype);
+	if (s == NULL)
+		return ENOMEM;
+
+	*rstr = s;
+	return EOK;
+}
+
+/** Format partition kind as string.
+ *
+ * @param pkind Partition kind
+ * @param rstr Place to return pointer to newly allocated string
+ * @return EOK on success, ENOMEM if out of memory
+ */
+int label_pkind_format(label_pkind_t pkind, char **rstr)
+{
+	const char *spkind;
+	char *s;
+
+	spkind = NULL;
+	switch (pkind) {
+	case lpk_primary:
+		spkind = "Primary";
+		break;
+	case lpk_extended:
+		spkind = "Extended";
+		break;
+	case lpk_logical:
+		spkind = "Logical";
+		break;
+	}
+
+	s = str_dup(spkind);
+	if (s == NULL)
+		return ENOMEM;
+
+	*rstr = s;
+	return EOK;
+}
+
+/** @}
+ */
Index: uspace/lib/c/generic/vol.c
===================================================================
--- uspace/lib/c/generic/vol.c	(revision 6e569bf0a1ed0572a905d116f5a08b3ebd525710)
+++ uspace/lib/c/generic/vol.c	(revision db9c88924815f5224f632a9114b5427633cf77dc)
@@ -304,4 +304,78 @@
 }
 
+/** Format file system type as string.
+ *
+ * @param fstype File system type
+ * @param rstr Place to store pointer to newly allocated string
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t vol_fstype_format(vol_fstype_t fstype, char **rstr)
+{
+	const char *sfstype;
+	char *s;
+
+	sfstype = NULL;
+	switch (fstype) {
+	case fs_exfat:
+		sfstype = "ExFAT";
+		break;
+	case fs_fat:
+		sfstype = "FAT";
+		break;
+	case fs_minix:
+		sfstype = "MINIX";
+		break;
+	case fs_ext4:
+		sfstype = "Ext4";
+		break;
+	case fs_cdfs:
+		sfstype = "ISO 9660";
+		break;
+	}
+
+	s = str_dup(sfstype);
+	if (s == NULL)
+		return ENOMEM;
+
+	*rstr = s;
+	return EOK;
+}
+
+/** Format partition content / file system type as string.
+ *
+ * @param pcnt Partition content
+ * @param fstype File system type
+ * @param rstr Place to store pointer to newly allocated string
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t vol_pcnt_fs_format(vol_part_cnt_t pcnt, vol_fstype_t fstype,
+    char **rstr)
+{
+	int rc;
+	char *s = NULL;
+
+	switch (pcnt) {
+	case vpc_empty:
+		s = str_dup("Empty");
+		if (s == NULL)
+			return ENOMEM;
+		break;
+	case vpc_fs:
+		rc = vol_fstype_format(fstype, &s);
+		if (rc != EOK)
+			return ENOMEM;
+		break;
+	case vpc_unknown:
+		s = str_dup("Unknown");
+		if (s == NULL)
+			return ENOMEM;
+		break;
+	}
+
+	assert(s != NULL);
+	*rstr = s;
+	return EOK;
+}
+
 /** @}
  */
Index: uspace/lib/c/include/io/label.h
===================================================================
--- uspace/lib/c/include/io/label.h	(revision db9c88924815f5224f632a9114b5427633cf77dc)
+++ uspace/lib/c/include/io/label.h	(revision db9c88924815f5224f632a9114b5427633cf77dc)
@@ -0,0 +1,47 @@
+/*
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_IO_LABEL_H_
+#define LIBC_IO_LABEL_H_
+
+#include <types/label.h>
+
+extern int label_type_format(label_type_t, char **);
+extern int label_pkind_format(label_pkind_t, char **);
+
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/types/vol.h
===================================================================
--- uspace/lib/c/include/types/vol.h	(revision 6e569bf0a1ed0572a905d116f5a08b3ebd525710)
+++ uspace/lib/c/include/types/vol.h	(revision db9c88924815f5224f632a9114b5427633cf77dc)
@@ -37,4 +37,5 @@
 
 #include <async.h>
+#include <ipc/vfs.h>
 #include <ipc/vol.h>
 #include <stdbool.h>
@@ -75,4 +76,8 @@
 	/** Volume label */
 	char label[VOL_LABEL_MAXLEN + 1];
+	/** Current mount point */
+	char cur_mp[MAX_PATH_LEN + 1]; /* XXX too big */
+	/** Current mount point is automatic */
+	bool cur_mp_auto;
 } vol_part_info_t;
 
Index: uspace/lib/c/include/vol.h
===================================================================
--- uspace/lib/c/include/vol.h	(revision 6e569bf0a1ed0572a905d116f5a08b3ebd525710)
+++ uspace/lib/c/include/vol.h	(revision db9c88924815f5224f632a9114b5427633cf77dc)
@@ -37,4 +37,5 @@
 
 #include <async.h>
+#include <errno.h>
 #include <loc.h>
 #include <stdint.h>
@@ -47,7 +48,11 @@
 extern errno_t vol_part_add(vol_t *, service_id_t);
 extern errno_t vol_part_info(vol_t *, service_id_t, vol_part_info_t *);
+extern errno_t vol_part_eject(vol_t *, service_id_t);
 extern errno_t vol_part_empty(vol_t *, service_id_t);
 extern errno_t vol_part_get_lsupp(vol_t *, vol_fstype_t, vol_label_supp_t *);
 extern errno_t vol_part_mkfs(vol_t *, service_id_t, vol_fstype_t, const char *);
+
+extern errno_t vol_fstype_format(vol_fstype_t, char **);
+extern errno_t vol_pcnt_fs_format(vol_part_cnt_t, vol_fstype_t, char **);
 
 #endif
Index: uspace/lib/fdisk/include/fdisk.h
===================================================================
--- uspace/lib/fdisk/include/fdisk.h	(revision 6e569bf0a1ed0572a905d116f5a08b3ebd525710)
+++ uspace/lib/fdisk/include/fdisk.h	(revision db9c88924815f5224f632a9114b5427633cf77dc)
@@ -37,4 +37,5 @@
 #define LIBFDISK_FDISK_H_
 
+#include <errno.h>
 #include <loc.h>
 #include <types/fdisk.h>
@@ -72,8 +73,4 @@
 extern void fdisk_pspec_init(fdisk_part_spec_t *);
 
-extern errno_t fdisk_ltype_format(label_type_t, char **);
-extern errno_t fdisk_fstype_format(vol_fstype_t, char **);
-extern errno_t fdisk_pkind_format(label_pkind_t, char **);
-
 extern errno_t fdisk_get_vollabel_support(fdisk_dev_t *, vol_fstype_t,
     vol_label_supp_t *);
Index: uspace/lib/fdisk/src/fdisk.c
===================================================================
--- uspace/lib/fdisk/src/fdisk.c	(revision 6e569bf0a1ed0572a905d116f5a08b3ebd525710)
+++ uspace/lib/fdisk/src/fdisk.c	(revision db9c88924815f5224f632a9114b5427633cf77dc)
@@ -813,88 +813,4 @@
 }
 
-errno_t fdisk_ltype_format(label_type_t ltype, char **rstr)
-{
-	const char *sltype;
-	char *s;
-
-	sltype = NULL;
-	switch (ltype) {
-	case lt_none:
-		sltype = "None";
-		break;
-	case lt_mbr:
-		sltype = "MBR";
-		break;
-	case lt_gpt:
-		sltype = "GPT";
-		break;
-	}
-
-	s = str_dup(sltype);
-	if (s == NULL)
-		return ENOMEM;
-
-	*rstr = s;
-	return EOK;
-}
-
-errno_t fdisk_fstype_format(vol_fstype_t fstype, char **rstr)
-{
-	const char *sfstype;
-	char *s;
-
-	sfstype = NULL;
-	switch (fstype) {
-	case fs_exfat:
-		sfstype = "ExFAT";
-		break;
-	case fs_fat:
-		sfstype = "FAT";
-		break;
-	case fs_minix:
-		sfstype = "MINIX";
-		break;
-	case fs_ext4:
-		sfstype = "Ext4";
-		break;
-	case fs_cdfs:
-		sfstype = "ISO 9660";
-		break;
-	}
-
-	s = str_dup(sfstype);
-	if (s == NULL)
-		return ENOMEM;
-
-	*rstr = s;
-	return EOK;
-}
-
-errno_t fdisk_pkind_format(label_pkind_t pkind, char **rstr)
-{
-	const char *spkind;
-	char *s;
-
-	spkind = NULL;
-	switch (pkind) {
-	case lpk_primary:
-		spkind = "Primary";
-		break;
-	case lpk_extended:
-		spkind = "Extended";
-		break;
-	case lpk_logical:
-		spkind = "Logical";
-		break;
-	}
-
-	s = str_dup(spkind);
-	if (s == NULL)
-		return ENOMEM;
-
-	*rstr = s;
-	return EOK;
-}
-
 /** Get free partition index. */
 static errno_t fdisk_part_get_free_idx(fdisk_dev_t *dev, int *rindex)
